#!/usr/bin/perl 
#use strict;
#use warnings;

# zabbix path
my $zabbix_sender="/usr/bin/zabbix_sender";
my $zabbix_confd="/etc/zabbix/zabbix_agentd.conf";
my $send_file="/var/tmp/zabbixSenderFileSendmail";
my $zabbix_send_command="$zabbix_sender -c $zabbix_confd ";
my $inputString = '';
my $hostname = `/bin/hostname -f`;
chomp($hostname);

# signal handling
$SIG{'ALRM'} = sub {
        local $SIG{TERM} = 'IGNORE';
        kill TERM => -$$;
        print "0\n";
};

local $SIG{TERM} = sub {
        local $SIG{TERM} = 'IGNORE';
        kill TERM => -$$;
        print "0\n";
};

# Initialize variables
my $from = ""; my $subject = ""; my $zabbixtimestamp = "";my $receivedtime = ""; my $delta = 0;
# Get timestamp
$receivedtime=time();
$receivedtime=~s/\%//;

# Parse mail
while (<STDIN>) {
($from)=($_ =~ /From:(.*)/) if ( (! $from) && (/From:/) );
($subject)=($_ =~ /Subject:(.*)/) if ( (! $subject) && (/Subject:/) );
# When timestamp found exit out of loop
if ( (! $zabbixtimestamp) && (/Zabbix-Time-Stamp:/) ){
($zabbixtimestamp)=($_ =~ /Zabbix-Time-Stamp:([0-9]*)/);
my $delta=$receivedtime-$zabbixtimestamp;
last;
}
}

# send information to Zabbix server
alarm 5;
if ( qx($zabbix_send_command -k mail.delta -o $delta) =~ /failed:\ 1/ ) { print"0\n"; exit(-1);}

print "1\n";
exit(0);
